<template>
  <div
      class="WAL position-relative bg-grey-4"
      :style="style"
      ref="chatContainer"
  >
    <q-layout
        view="lHh Lpr lFf"
        class="WAL__layout shadow-3"
        container
    >
      <q-header elevated>
        <q-toolbar
            class="bg-grey-3 text-black"
            :class="{'flex flex-wrap': screenWidth <1000}"
        >
          <q-btn
              round
              flat
              icon="keyboard_arrow_left"
              class="WAL__drawer-open q-mr-sm"
              @click="toggleLeftDrawer"
          />
        </q-toolbar>
      </q-header>

      <q-drawer
          v-model="leftDrawerOpen"
          show-if-above
          bordered
          :breakpoint="690"
          :width="390"
      >
        <q-toolbar class="bg-grey-3">
          <span class="text-xl q-pl-md">
            <q-icon name="settings" size="md" class="mr-4" />Настройки
          </span>

          <q-space />

          <q-btn
              round
              flat
              icon="close"
              class="WAL__drawer-close"
              @click="toggleLeftDrawer"
          />
        </q-toolbar>
        <div class="text-sm bg-green-3 absolute bottom-0 w-full flex">
          <div class="ml-4 mr-12">Диск</div>
          <div class="mr-4">Свободно: {{system?.disks[1]?.target}}</div>
          <div>Всего: {{system?.disks[1]?.avail}}</div>
        </div>
        <q-scroll-area style="height: calc(100% - 100px)">
          <div class="q-pa-md">
            <q-list bordered class="rounded-borders">
              <q-expansion-item
                  v-if="roleMiddleware(['suHOS', 'ADMIN'])"
                  expand-separator
                  icon="settings_applications"
                  label="Основные настройки"
                  caption="Название CRM, обьявления и прочее"
                  header-class="text-lg"
              >
                <q-card>
                  <q-card-section>
                    <q-item clickable @click="tab = 'name-main'" :class="{'bg-green-200':tab === 'name-main'}">Название CRM</q-item>
                    <q-item clickable @click="tab = 'notice-main'" :class="{'bg-green-200':tab === 'notice-main'}">Обьявления</q-item>
                    <q-item clickable @click="tab = 'company-main'" :class="{'bg-green-200':tab === 'company-main'}">Название компании</q-item>
                  </q-card-section>
                </q-card>
              </q-expansion-item>
              <q-expansion-item
                  v-if="roleMiddleware(['HOS', 'suHOS', 'ADMIN'])"
                  expand-separator
                  icon="people"
                  label="Пользователи"
                  caption="Управление пользователями CRM"
                  header-class="text-lg"
              >
                <q-card>
                  <q-card-section>
                    <q-item clickable @click="tab = 'all-user'" :class="{'bg-green-200':tab === 'all-user'}">Все пользователи</q-item>
                    <q-item clickable @click="tab = 'new-user'" :class="{'bg-green-200':tab === 'new-user'}">Добавить пользователя</q-item>
                  </q-card-section>
                </q-card>
              </q-expansion-item>
              <q-item v-if="roleMiddleware(['suHOS', 'ADMIN'])" clickable @click="tab = 'status'" :class="{'bg-green-200':tab === 'status'}">
                <q-icon name="list" size="sm"/>
                <p class="text-lg ml-9">Воронки продаж</p>
              </q-item>
              <q-item v-if="roleMiddleware(['suHOS', 'ADMIN'])" clickable @click="tab = 'task'" :class="{'bg-green-200':tab === 'task'}">
                <q-icon name="task" size="sm"/>
                <p class="text-lg ml-9">Задачи</p>
              </q-item>
              <q-expansion-item
                  v-if="roleMiddleware(['suHOS', 'ADMIN'])"
                  icon="contact_page"
                  label="Дополнительные поля"
                  header-class="text-lg"
                  caption="Управление полями в лиде (контакты, статьи и т.д.)"
              >
                <q-card>
                  <q-card-section>
                    <q-item clickable @click="tab = '1-fields'" :class="{'bg-green-200':tab === '-fields'}">Контакты</q-item>
                    <q-item clickable @click="tab = '2-fields'" :class="{'bg-green-200':tab === '-fields'}">Сделки</q-item>
                    <q-item clickable @click="tab = '3-fields'" :class="{'bg-green-200':tab === '-fields'}">Регион</q-item>
                    <q-item clickable @click="tab = 'new-fields'" :class="{'bg-green-200':tab === '-fields'}">Новое поле</q-item>
                  </q-card-section>
                </q-card>
              </q-expansion-item>

              <q-item v-if="roleMiddleware(['suHOS', 'ADMIN'])" clickable @click="tab = 'region'" :class="{'bg-green-200':tab === 'region'}">
                <q-icon name="pin_drop" size="sm"/>
                <p class="text-lg ml-9">Регионы</p>
              </q-item>
              <q-item v-if="roleMiddleware(['suHOS', 'ADMIN'])" clickable @click="tab = 'message'" :class="{'bg-green-200':tab === 'message'}">
                <q-icon name="email" size="sm"/>
                <p class="text-lg ml-9">Шаблоны сообщений</p>
              </q-item>
            </q-list>
          </div>
        </q-scroll-area>
      </q-drawer>

      <q-page-container class="bg-grey-2">
        <div class="q-pa-md">
          <div v-if="tab === ''" class="flex items-center justify-center">
            <q-icon name="settings" color="blue" size="50px"/>
            <p class="text-3xl ml-4">Настройки</p>
          </div>
          <MainSetting v-if="tab.indexOf('-main') > 0" :tab="tab" />
          <UserSettings v-if="tab.indexOf('-user') > 0" :tab="tab" />
          <StatusSettings v-if="tab === 'status'" />
          <TaskSettings v-if="tab==='task'"/>
          <FieldsSettings v-if="tab.indexOf('-fields') > 0" />
          <RegionSettings v-if="tab === 'region'"/>
          <TempMessageSettings v-if="tab==='message'" />
        </div>
      </q-page-container>

      <q-footer>
        <q-toolbar class="bg-grey-3 text-black row py-4">

        </q-toolbar>
      </q-footer>
    </q-layout>
  </div>
</template>

<script>
import {useStore} from "vuex";
import {useRoute, useRouter} from "vue-router";
import {computed, onMounted, ref} from "vue";
import api from "../../API/api";
import {stream} from "../../API/stream";
import {useLogLead} from "../../components/useLogLead";
import address from "../../API/address";
import {useUpdateLead} from "../../components/useUpdateLead";
import formattedDate from "../../utils/formatDate";
import {useQuasar} from "quasar";
import MainSetting from "./Main-setting.vue";
import UserSettings from "./User-settings.vue";
import StatusSettings from "./Status-settings.vue";
import TaskSettings from "./Task-settings.vue";
import FieldsSettings from "./Fields-settings.vue";
import RegionSettings from "./Region-settings.vue";
import TempMessageSettings from "./Temp-Message-settings.vue";
import {roleMiddleware} from "../../components/roleMiddleware";

export default {
  name: "Settings",
  components: {
    TempMessageSettings,
    RegionSettings, FieldsSettings, TaskSettings, StatusSettings, UserSettings, MainSetting},
  setup () {
    const store = useStore()
    const user = store.state.user
    const $q = useQuasar()

    const system = ref(null)

    async function init () {
      const res = await api.getSystemInfo()
      system.value = res.data.system
    }
    init()

    const leftDrawerOpen = ref(false)
    const search = ref('')
    const currentConversationIndex = ref(0)


    const style = computed(() => ({
      height: $q.screen.height - 50 + 'px'
    }))
    const screenWidth = computed(() => $q.screen.width)

    function toggleLeftDrawer () {
      leftDrawerOpen.value = !leftDrawerOpen.value
    }

    function setCurrentConversation (index) {
      currentConversationIndex.value = index
    }
    return {
      useUpdateLead,
      roleMiddleware,
      user,
      system,
      formattedDate,

      tab: ref(''),

      leftDrawerOpen,
      search,
      currentConversationIndex,
      setCurrentConversation,
      style,
      screenWidth,
      toggleLeftDrawer,

      host: computed(() => 'https://technik-crm.ru'),
      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>


<style lang="sass">
.WAL
  width: 100%
  height: 100%
  padding-top: 20px
  padding-bottom: 20px

  &:before
    content: ''
    height: 127px
    position: fixed
    top: 0
    width: 100%

  &__layout
    margin: 0 auto
    z-index: 4000
    height: 100%
    width: 97%
    border-radius: 5px

  &__field.q-field--outlined .q-field__control:before
    border: none

  .q-drawer--standard
    .WAL__drawer-close
      display: none

@media (max-width: 850px)
  .WAL
    padding: 0
    &__layout
      width: 100%
      border-radius: 0

@media (min-width: 691px)
  .WAL
    &__drawer-open
      display: none

.conversation__summary
  margin-top: 4px

.conversation__more
  margin-top: 0!important
  font-size: 1.4rem
</style>